package de.intevation.flys.artifacts.model;

import de.intevation.artifactdatabase.state.Facet;

import de.intevation.flys.artifacts.states.DefaultState.ComputeType;

import de.intevation.flys.artifacts.math.Sub;

public class NormalizedReferenceCurveFacet
extends      ReferenceCurveFacet
{
    public NormalizedReferenceCurveFacet() {
    }

    public NormalizedReferenceCurveFacet(
        int    index,
        String name,
        String description
    ) {
        super(index, name, description, ComputeType.ADVANCE, null, null);
    }

    public NormalizedReferenceCurveFacet(
        int         index,
        String      name,
        String      description,
        ComputeType type,
        String      stateID,
        String      hash
    ) {
        super(index, name, description, type, hash, stateID);
    }

    @Override
    protected Object getInternalData(WW [] wws) {
        return new WW.ApplyFunctionIterator(wws[index]) {
            {
                function1 = new Sub(ww.minWs());
                function2 = new Sub(ww.minWs2());
            }
        };
    }

    /** Copy deeply. */
    @Override
    public Facet deepCopy() {
        NormalizedReferenceCurveFacet copy =
            new NormalizedReferenceCurveFacet();
        copy.set(this);
        return copy;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
